using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEditor;
using UnityFBXExporter;
using UnityEditor.Formats.Fbx.Exporter;
using Object = UnityEngine.Object;
using UnityEngine.Networking;
using UnityEngine.UI;



public class meshGenerator : MonoBehaviour
{


    // Start is called before the first frame update
    private Mesh mesh;
    private GameObject cubeObject;


    //private MeshCollider meshcol;
    [SerializeField] private string authentcationEndpoint = "http://192.168.80.1:3000/";

    public RawImage importImage;
    private string pdfFileType;
    private string pathone;
    public Button importButton;
    [SerializeField] private Button uploadButton;
    private Texture2D uwrTextureyy;
    //PlayerPrefs.GetString("_id");


    //private int[] xx = { 723, 722, 721, 720, 719, 718, 717, 716, 715, 714, 713, 712, 711, 200, 709, 708, 707, 706, 705, 704, 703, 702, 701, 700, 699, 698, 697, 696, 695, 694, 693, 692, 691, 690, 689, 688, 687, 686, 685, 684, 683, 682, 681, 680, 679, 678, 677, 676, 675, 674, 673, 672, 671, 670, 669, 668, 667, 666, 665, 664, 663, 662, 661, 660, 659, 658, 657, 656, 655, 654, 653, 652, 651, 650, 649, 648, 647, 646, 645, 644, 643, 642, 641, 640, 639, 638, 637, 636, 635, 634, 633, 632, 631, 630, 629, 628, 627, 626, 625, 624, 623, 622, 621, 620, 619, 618, 617, 616, 615, 614, 613, 612, 611, 610, 609, 608, 607, 606, 605, 604, 603, 602, 601, 600, 599, 598, 597, 596, 595, 594, 593, 592, 591, 590, 589, 588, 587, 586, 585, 584, 583, 582, 581, 580, 579, 579, 578, 577, 576, 575, 575, 574, 573, 572, 571, 570, 569, 569, 568, 567, 566, 565, 564, 563, 562, 561, 560, 559, 558, 558, 557, 557, 556, 555, 554, 553, 553, 552, 551, 551, 550, 549, 549, 548, 548, 547, 546, 545, 544, 543, 543, 542, 542, 541, 540, 540, 539, 538, 538, 537, 537, 536, 536, 535, 534, 534, 534, 533, 533, 532, 531, 531, 531, 530, 530, 530, 530, 529, 529, 528, 527, 527, 526, 526, 526, 525, 524, 524, 524, 523, 523, 522, 522, 522, 522, 522, 521, 521, 521, 521, 521, 521, 520, 520, 520, 520, 519, 518, 518, 518, 517, 517, 517, 517, 517, 517, 516, 516, 516, 515, 515, 515, 515, 514, 514, 513, 513, 512, 512, 511, 510, 509, 509, 509, 508, 507, 507, 506, 505, 504, 504, 503, 502, 501, 501, 500, 499, 498, 497, 496, 495, 494, 493, 492, 491, 490, 489, 488, 487, 486, 485, 484, 483, 482, 481, 480, 479, 478, 477, 476, 475, 474, 473, 472, 471, 470, 469, 468, 467, 466, 465, 464, 463, 462, 461, 460, 459, 458, 457, 456, 455, 454, 453, 452, 451, 450, 449, 448, 447, 446, 445, 444, 443, 442, 441, 440, 439, 438, 437, 436, 435, 434, 433, 432, 431, 430, 429, 428, 427, 426, 425, 424, 423, 422, 421, 420, 419, 418, 417, 416, 415, 414, 413, 412, 411, 410, 409, 408, 407, 406, 405, 404, 403, 402, 401, 400, 399, 398, 397, 396, 395, 394, 393, 392, 391, 390, 389, 388, 387, 386, 385, 384, 383, 382, 381, 380, 379, 378, 377, 376, 375, 374, 373, 372, 371, 370, 369, 368, 367, 366, 365, 364, 363, 362, 361, 360, 359, 358, 357, 356, 355, 354, 353, 352, 351, 350, 349, 348, 347, 346, 345, 344, 343, 342, 341, 340, 339, 338, 337, 336, 335, 334, 333, 332, 331, 330, 329, 328, 327, 326, 325, 324, 323, 322, 321, 320, 319, 318, 317, 316, 315, 314, 313, 312, 311, 310, 309, 308, 307, 306, 305, 304, 303, 302, 301, 300, 299, 298, 297, 296, 295, 294, 293, 292, 291, 290, 289, 288, 287, 286, 285, 284, 283, 282, 281, 280, 279, 278, 277, 276, 275, 274, 273, 272, 271, 270, 269, 268, 267, 266, 265, 264, 263, 262, 262, 261, 260, 259, 258, 257, 256, 255, 254, 253, 252, 251, 250, 249, 248, 247, 246, 245, 244, 243, 242, 241, 240, 239, 238, 237, 236, 236, 235, 234, 233, 232, 231, 230, 230, 230, 229, 228, 227, 226, 226, 225, 224, 223, 222, 222, 221, 220, 220, 219, 218, 217, 216, 215, 214, 213, 213, 212, 211, 210, 209, 208, 207, 206, 206, 205, 205, 204, 204, 203, 203, 202, 201, 200, 199, 199, 198, 197, 197, 196, 196, 195, 194, 194, 193, 193, 192, 191, 191, 190, 190, 189, 188, 188, 187, 186, 186, 185, 184, 184, 183, 183, 182, 181, 181, 180, 180, 179, 179, 178, 178, 177, 176, 176, 175, 175, 174, 174, 174, 173, 172, 171, 171, 171, 170, 169, 169, 168, 168, 167, 167, 167, 166, 166, 166, 166, 165, 164, 164, 163, 163, 162, 162, 162, 161, 161, 161, 160, 159, 159, 158, 158, 158, 157, 157, 157, 156, 156, 155, 154, 154, 154, 153, 153, 152, 152, 151, 151, 151, 150, 150, 150, 150, 149, 149, 149, 148, 148, 148, 148, 148, 147, 147, 147, 147, 146, 145, 145, 145, 145, 144, 144, 144, 144, 143, 143, 143, 142, 142, 142, 141, 141, 141, 141, 140, 140, 140, 140, 139, 139, 139, 139, 138, 138, 138, 138, 138, 137, 137, 137, 137, 137, 137, 136, 136, 136, 136, 136, 136, 136, 136, 136, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 135, 135, 135, 135, 135, 135, 136, 136, 136, 136, 136, 137, 137, 137, 138, 138, 138, 139, 139, 139, 139, 139, 139, 139, 140, 140, 140, 140, 141, 141, 141, 142, 142, 142, 142, 143, 143, 144, 144, 144, 144, 145, 145, 145, 146, 146, 146, 147, 147, 147, 148, 148, 148, 148, 149, 150, 150, 150, 151, 151, 151, 152, 152, 152, 153, 153, 154, 155, 155, 156, 156, 156, 157, 157, 158, 159, 159, 159, 160, 160, 161, 161, 162, 163, 163, 164, 164, 165, 165, 166, 167, 167, 168, 168, 169, 169, 170, 171, 171, 172, 173, 173, 174, 174, 175, 176, 177, 177, 178, 179, 179, 180, 180, 181, 182, 183, 183, 184, 185, 186, 186, 187, 188, 189, 190, 191, 192, 192, 193, 194, 195, 196, 197, 197, 198, 199, 199, 200, 201, 202, 203, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 212, 213, 214, 215, 215, 216, 217, 217, 218, 219, 220, 221, 222, 223, 224, 225, 225, 226, 227, 228, 229, 229, 230, 231, 232, 233, 233, 234, 234, 235, 236, 237, 238, 238, 239, 240, 241, 242, 242, 243, 244, 245, 246, 247, 247, 248, 247, 247, 247, 247, 247, 247, 247, 247, 248, 248, 249, 250, 250, 251, 251, 251, 252, 252, 252, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 261, 262, 263, 264, 265, 266, 266, 267, 268, 269, 269, 270, 271, 271, 272, 273, 273, 273, 273, 273, 273, 273, 273, 273, 274, 274, 274, 274, 275, 275, 276, 277, 278, 279, 280, 280, 281, 281, 281, 281, 280, 279, 278, 277, 276, 275, 274, 273, 272, 271, 270, 269, 268, 267, 266, 265, 264, 263, 262, 261, 260, 259, 258, 257, 256, 255, 255, 254, 253, 252, 251, 250, 249, 248, 247, 246, 245, 245, 244, 243, 242, 241, 240, 239, 238, 238, 237, 236, 235, 235, 234, 233, 233, 232, 231, 230, 229, 229, 228, 227, 227, 226, 225, 225, 224, 223, 222, 222, 221, 221, 220, 220, 219, 218, 217, 217, 216, 216, 215, 214, 214, 213, 213, 212, 212, 211, 211, 210, 209, 209, 208, 207, 207, 206, 206, 205, 205, 204, 204, 203, 203, 203, 202, 202, 202, 201, 201, 201, 201, 201, 200, 200, 200, 200, 199, 199, 199, 198, 198, 198, 198, 198, 198, 198, 198, 198, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 196, 196, 196, 196, 196, 196, 196, 196, 196, 196, 196, 195, 195, 195, 195, 194, 194, 194, 194, 194, 194, 193, 193, 193, 193, 193, 193, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 193, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 194, 195, 195, 195, 195, 195, 195, 195, 195, 195, 196, 196, 196, 196, 196, 196, 196, 196, 197, 197, 197, 197, 197, 197, 197, 197, 198, 198, 198, 199, 199, 199, 199, 199, 199, 200, 200, 200, 200, 200, 201, 201, 201, 202, 202, 202, 202, 203, 203, 203, 203, 204, 204, 204, 204, 205, 206, 206, 206, 207, 207, 208, 208, 209, 209, 210, 210, 211, 211, 212, 212, 213, 213, 214, 214, 215, 215, 216, 216, 217, 218, 219, 219, 220, 221, 222, 223, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 250, 250, 250, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364, 365, 366, 367, 367, 368, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 384, 385, 386, 387, 388, 389, 390, 391, 391, 392, 393, 393, 394, 394, 395, 396, 396, 396, 397, 398, 399, 400, 400, 400, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 399, 400, 400, 400, 400, 400, 400, 400, 400, 400, 400, 400, 400, 401, 401, 401, 401, 401, 402, 402, 402, 402, 402, 402, 403, 403, 403, 403, 403, 403, 404, 404, 404, 405, 405, 405, 405, 406, 406, 407, 407, 407, 407, 408, 408, 408, 408, 408, 409, 409, 409, 410, 410, 410, 411, 411, 411, 411, 412, 412, 412, 413, 413, 413, 414, 414, 414, 415, 415, 415, 416, 416, 416, 416, 417, 417, 417, 418, 418, 418, 419, 419, 419, 420, 420, 420, 421, 422, 422, 422, 422, 423, 423, 423, 423, 424, 425, 425, 426, 426, 426, 427, 427, 427, 428, 428, 428, 429, 429, 429, 430, 431, 432, 432, 432, 433, 433, 434, 434, 435, 435, 435, 436, 436, 437, 437, 438, 439, 439, 439, 440, 440, 441, 441, 442, 443, 443, 444, 444, 445, 445, 446, 447, 448, 448, 448, 449, 449, 450, 451, 452, 452, 453, 453, 454, 455, 456, 457, 457, 457, 458, 459, 459, 460, 461, 461, 462, 463, 463, 464, 465, 466, 466, 467, 467, 468, 469, 470, 470, 471, 472, 472, 473, 474, 475, 475, 476, 477, 478, 479, 480, 481, 482, 483, 484, 484, 485, 486, 487, 488, 489, 490, 491, 492, 493, 494, 495, 496, 497, 498, 499, 500, 501, 502, 503, 504, 505, 506, 507, 508, 509, 510, 511, 512, 513, 514, 515, 516, 517, 518, 519, 520, 521, 522, 523, 524, 525, 526, 527, 528, 529, 530, 531, 532, 533, 534, 535, 536, 537, 538, 539, 540, 541, 542, 543, 544, 545, 546, 547, 548, 549, 550, 551, 552, 553, 554, 555, 556, 557, 558, 559, 560, 561, 562, 563, 564, 565, 566, 567, 568, 569, 570, 571, 572, 573, 574, 575, 576, 577, 578, 579, 580, 581, 582, 583, 584, 585, 586, 587, 588, 589, 590, 591, 592, 593, 594, 595, 596, 597, 598, 599, 600, 601, 602, 603, 604, 605, 606, 607, 608, 609, 610, 611, 612, 613, 614, 615, 616, 617, 618, 619, 620, 621, 622, 623, 624, 625, 626, 627, 628, 629, 630, 631, 632, 633, 634, 635, 636, 637, 638, 639, 640, 641, 642, 643, 644, 645, 646, 647, 648, 649, 650, 651, 652, 653, 654, 655, 656, 657, 658, 659, 660, 661, 662, 663, 664, 665, 666, 667, 668, 669, 670, 671, 672, 673, 674, 675, 676, 677, 678, 679, 680, 681, 682, 683, 684, 685, 686, 687, 688, 689, 690, 691, 692, 693, 694, 695, 696, 697, 698, 699, 700, 701, 702, 703, 704, 705, 706, 707, 708, 709, 710, 711, 712, 713, 714, 715, 716, 717, 718, 719, 720, 721, 721, 721, 722, 723, 724, 725, 726, 727, 728, 729, 730, 731, 732, 733, 734, 735, 736, 737, 738, 739, 740, 741, 742, 743, 744, 745, 746, 747, 748, 749, 750, 751, 752, 753, 754, 755, 756, 757, 758, 759, 760, 761, 762, 763, 764, 765, 766, 767, 768, 769, 770, 771, 772, 773, 774, 775, 776, 777, 778, 779, 780, 781, 782, 783, 784, 785, 786, 787, 788, 789, 790, 791, 792, 793, 794, 795, 796, 797, 798, 799, 800, 801, 802, 803, 804, 805, 806, 807, 808, 809, 810, 811, 812, 813, 814, 815, 816, 817, 818, 819, 820, 821, 822, 823, 824, 825, 826, 827, 828, 829, 830, 831, 832, 833, 834, 835, 836, 837, 838, 839, 840, 841, 842, 843, 844, 845, 846, 847, 848, 849, 849, 850, 851, 852, 853, 854, 855, 856, 857, 858, 858, 859, 860, 861, 861, 862, 863, 864, 865, 866, 867, 868, 869, 870, 870, 871, 872, 873, 873, 874, 875, 876, 876, 877, 878, 878, 879, 880, 881, 881, 882, 883, 884, 884, 885, 885, 886, 887, 887, 888, 889, 889, 890, 891, 892, 892, 893, 893, 894, 894, 894, 895, 895, 895, 896, 896, 897, 898, 898, 898, 899, 899, 900, 901, 901, 901, 902, 902, 903, 903, 904, 904, 905, 905, 906, 906, 907, 907, 907, 908, 908, 908, 909, 910, 910, 910, 911, 911, 911, 911, 912, 912, 912, 913, 913, 914, 914, 914, 914, 915, 915, 915, 915, 915, 915, 916, 916, 917, 917, 917, 917, 917, 918, 918, 918, 918, 918, 919, 919, 919, 919, 920, 920, 920, 920, 920, 920, 921, 921, 921, 921, 922, 922, 922, 922, 922, 922, 923, 923, 923, 923, 923, 924, 924, 924, 924, 924, 925, 925, 925, 925, 925, 925, 926, 926, 926, 926, 927, 927, 927, 927, 927, 927, 927, 927, 927, 928, 928, 928, 928, 928, 928, 928, 928, 928, 927, 927, 927, 927, 927, 928, 928, 928, 928, 928, 928, 928, 928, 928, 928, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 930, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 975, 976, 977, 978, 979, 980, 981, 982, 983, 984, 985, 986, 986, 986, 986, 986, 986, 986, 985, 984, 983, 982, 981, 980, 979, 978, 977, 976, 975, 974, 973, 972, 971, 970, 969, 968, 969, 970, 971, 972, 973, 974, 975, 976, 977, 978, 979, 980, 981, 982, 983, 984, 985, 986, 987, 988, 989, 990, 991, 992, 993, 994, 995, 996, 997, 998, 999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1070, 1071, 1072, 1072, 1073, 1074, 1074, 1075, 1076, 1077, 1077, 1077, 1078, 1079, 1080, 1081, 1081, 1082, 1082, 1083, 1084, 1084, 1085, 1086, 1086, 1087, 1087, 1087, 1088, 1088, 1088, 1089, 1090, 1090, 1090, 1091, 1092, 1092, 1093, 1093, 1094, 1095, 1095, 1096, 1096, 1097, 1097, 1097, 1098, 1098, 1098, 1099, 1100, 1100, 1101, 1101, 1102, 1103, 1103, 1103, 1104, 1104, 1105, 1105, 1105, 1106, 1106, 1106, 1106, 1107, 1107, 1107, 1107, 1108, 1108, 1108, 1108, 1108, 1108, 1109, 1109, 1109, 1109, 1110, 1110, 1110, 1110, 1111, 1112, 1112, 1112, 1112, 1112, 1113, 1113, 1113, 1113, 1113, 1114, 1114, 1114, 1114, 1115, 1115, 1115, 1116, 1116, 1116, 1117, 1117, 1117, 1118, 1118, 1118, 1118, 1119, 1119, 1119, 1119, 1119, 1119, 1120, 1120, 1120, 1120, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1122, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 1121, 1121, 1121, 1121, 1120, 1120, 1120, 1119, 1119, 1119, 1119, 1119, 1118, 1118, 1118, 1117, 1116, 1116, 1115, 1115, 1115, 1115, 1115, 1114, 1114, 1113, 1113, 1113, 1113, 1113, 1112, 1112, 1112, 1112, 1112, 1112, 1111, 1111, 1111, 1110, 1110, 1110, 1110, 1110, 1110, 1109, 1109, 1109, 1109, 1109, 1108, 1108, 1108, 1108, 1107, 1107, 1107, 1107, 1106, 1106, 1106, 1106, 1105, 1105, 1105, 1104, 1104, 1104, 1104, 1103, 1103, 1103, 1103, 1103, 1102, 1102, 1102, 1102, 1101, 1101, 1101, 1100, 1099, 1099, 1099, 1099, 1098, 1098, 1098, 1098, 1097, 1097, 1097, 1097, 1097, 1098, 1098, 1098, 1098, 1098, 1097, 1096, 1096, 1095, 1094, 1094, 1093, 1093, 1092, 1092, 1091, 1090, 1090, 1089, 1088, 1088, 1087, 1087, 1087, 1086, 1086, 1086, 1085, 1084, 1083, 1082, 1082, 1081, 1081, 1080, 1080, 1079, 1079, 1078, 1078, 1077, 1076, 1076, 1075, 1075, 1074, 1074, 1073, 1073, 1072, 1071, 1071, 1071, 1070, 1070, 1069, 1069, 1068, 1068, 1068, 1067, 1066, 1066, 1066, 1065, 1064, 1064, 1064, 1064, 1063, 1062, 1061, 1061, 1060, 1059, 1058, 1057, 1057, 1056, 1055, 1055, 1054, 1053, 1053, 1052, 1052, 1051, 1051, 1050, 1050, 1050, 1049, 1048, 1047, 1046, 1045, 1044, 1043, 1043, 1042, 1041, 1041, 1040, 1039, 1038, 1037, 1037, 1036, 1035, 1035, 1034, 1033, 1033, 1032, 1031, 1030, 1029, 1028, 1028, 1027, 1026, 1026, 1025, 1024, 1024, 1023, 1022, 1022, 1021, 1021, 1020, 1019, 1018, 1017, 1016, 1015, 1014, 1013, 1012, 1011, 1010, 1009, 1008, 1007, 1006, 1005, 1004, 1003, 1003, 1002, 1001, 1000, 1000, 1000, 999, 998, 997, 997, 996, 995, 994, 994, 993, 992, 991, 991, 990, 989, 988, 988, 987, 986, 985, 984, 984, 983, 982, 981, 980, 979, 978, 977, 976, 976, 975, 974, 973, 972, 971, 971, 970, 969, 968, 967, 966, 965, 964, 963, 962, 961, 961, 960, 959, 958, 957, 956, 955, 954, 954, 953, 952, 951, 950, 949, 948, 947, 946, 946, 945, 944, 944, 943, 942, 941, 940, 939, 938, 937, 936, 935, 934, 933, 932, 931, 930, 929, 928, 927, 926, 925, 924, 923, 922, 921, 920, 919, 918, 917, 916, 915, 914, 913, 912, 912, 911, 910, 909, 908, 907, 906, 905, 904, 903, 902, 902, 902, 902, 902, 902, 902, 903, 903, 903, 904, 904, 905, 905, 905, 906, 907, 907, 908, 908, 909, 909, 909, 910, 910, 911, 911, 912, 912, 912, 912, 912, 913, 913, 914, 915, 915, 916, 916, 916, 916, 916, 916, 917, 917, 917, 917, 918, 918, 919, 919, 919, 920, 920, 920, 920, 920, 921, 921, 921, 922, 922, 922, 923, 923, 923, 924, 924, 925, 925, 925, 925, 926, 926, 926, 926, 927, 927, 927, 928, 928, 929, 929, 929, 929, 930, 930, 931, 931, 931, 931, 932, 932, 932, 932, 932, 932, 933, 933, 933, 933, 933, 933, 933, 933, 933, 933, 934, 934, 934, 934, 934, 934, 934, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 935, 936, 936, 936, 936, 936, 936, 936, 936, 936, 936, 936, 936, 936, 936, 937, 937, 937, 937, 937, 937, 937, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 938, 937, 937, 937, 937, 937, 936, 936, 936, 936, 936, 936, 935, 935, 935, 935, 935, 935, 934, 934, 934, 934, 934, 934, 933, 933, 933, 933, 933, 933, 933, 933, 933, 933, 933, 933, 932, 932, 932, 932, 932, 931, 931, 931, 931, 931, 931, 931, 930, 930, 930, 930, 930, 930, 929, 929, 929, 929, 928, 928, 927, 927, 927, 926, 926, 925, 925, 924, 923, 923, 923, 923, 922, 922, 922, 922, 921, 921, 921, 920, 920, 919, 919, 918, 918, 917, 917, 916, 915, 915, 915, 914, 914, 913, 912, 912, 911, 910, 910, 909, 909, 908, 907, 907, 906, 905, 905, 904, 903, 902, 902, 901, 900, 900, 899, 898, 898, 897, 896, 895, 894, 893, 892, 891, 891, 890, 889, 888, 887, 887, 886, 885, 884, 883, 882, 881, 880, 879, 878, 877, 876, 875, 874, 873, 872, 871, 870, 869, 868, 867, 866, 865, 864, 863, 862, 861, 860, 859, 858, 857, 856, 855, 854, 853, 852, 851, 850, 849, 848, 847, 846, 845, 844, 843, 842, 841, 840, 839, 838, 837, 836, 835, 834, 833, 832, 831, 830, 829, 828, 827, 826, 825, 824, 823, 822, 821, 820, 819, 818, 817, 816, 815, 814, 813, 812, 811, 810, 809, 808, 807, 806, 805, 804, 803, 802, 801, 800, 799, 798, 797, 796, 795, 794, 793, 792, 791, 790, 789, 788, 787, 786, 785, 784, 783, 782, 781, 780, 779, 778, 777, 776, 775, 774, 773, 772, 771, 770, 769, 768, 767, 766, 765, 764, 763, 762, 761, 760, 759, 758, 757, 756, 755, 754, 753, 752, 751, 750, 749, 748, 747, 746, 745, 744, 743, 742, 741, 740, 739, 738, 737, 736, 735, 734, 733, 732, 731, 730, 729, 728, 727, 726, 725, 724 };
    //private int[] yy = { 354, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 356, 356, 356, 356, 356, 356, 356, 356, 357, 357, 357, 357, 357, 357, 357, 357, 357, 358, 358, 358, 358, 358, 359, 359, 359, 360, 360, 360, 360, 361, 361, 361, 361, 361, 362, 362, 362, 362, 362, 363, 363, 363, 363, 364, 364, 364, 364, 365, 365, 365, 366, 366, 367, 367, 367, 367, 368, 368, 368, 369, 369, 370, 370, 371, 371, 371, 372, 372, 372, 373, 373, 373, 374, 374, 374, 375, 375, 376, 376, 377, 377, 377, 378, 379, 379, 380, 380, 381, 381, 382, 383, 383, 384, 385, 385, 386, 386, 387, 387, 388, 388, 389, 389, 390, 391, 391, 392, 392, 393, 394, 394, 395, 396, 397, 397, 398, 399, 400, 400, 401, 402, 403, 404, 404, 405, 406, 407, 408, 409, 410, 411, 411, 412, 413, 414, 415, 416, 417, 418, 419, 420, 421, 422, 423, 424, 425, 426, 427, 428, 429, 430, 431, 432, 433, 434, 435, 436, 437, 438, 439, 440, 441, 442, 443, 444, 445, 446, 447, 448, 449, 450, 451, 452, 453, 454, 455, 456, 457, 458, 459, 460, 461, 462, 463, 464, 465, 466, 467, 468, 469, 470, 471, 472, 473, 474, 475, 476, 477, 478, 479, 480, 481, 482, 483, 484, 485, 486, 487, 488, 489, 490, 491, 492, 493, 494, 495, 496, 497, 498, 499, 500, 501, 502, 503, 504, 505, 504, 503, 502, 501, 500, 499, 498, 497, 496, 495, 494, 493, 492, 491, 490, 489, 488, 487, 486, 485, 484, 483, 482, 481, 480, 479, 478, 477, 476, 475, 474, 473, 472, 471, 470, 469, 468, 467, 466, 466, 465, 464, 463, 462, 462, 461, 460, 459, 458, 458, 457, 456, 455, 455, 454, 453, 452, 452, 451, 450, 450, 450, 449, 448, 448, 447, 447, 447, 446, 446, 445, 445, 445, 444, 444, 444, 443, 442, 441, 441, 441, 440, 440, 440, 440, 439, 439, 439, 439, 439, 438, 438, 438, 438, 437, 437, 437, 437, 436, 436, 436, 436, 436, 436, 436, 436, 436, 436, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 435, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 435, 435, 436, 436, 436, 436, 436, 437, 437, 437, 437, 437, 438, 438, 438, 438, 438, 438, 439, 439, 439, 440, 440, 440, 441, 441, 441, 441, 442, 442, 442, 442, 442, 443, 443, 443, 443, 443, 444, 444, 444, 444, 445, 445, 446, 446, 447, 447, 448, 448, 448, 448, 449, 450, 451, 451, 452, 452, 452, 452, 453, 453, 454, 455, 455, 456, 456, 456, 457, 457, 458, 458, 458, 459, 460, 461, 462, 462, 463, 464, 464, 464, 465, 466, 466, 467, 468, 469, 469, 470, 470, 471, 472, 473, 474, 474, 475, 476, 476, 477, 478, 479, 480, 481, 481, 482, 483, 483, 484, 485, 486, 486, 487, 488, 488, 489, 490, 490, 491, 492, 493, 494, 495, 496, 497, 498, 499, 499, 500, 501, 502, 503, 504, 505, 506, 506, 507, 508, 509, 510, 511, 511, 512, 513, 514, 515, 516, 517, 518, 519, 520, 521, 522, 522, 523, 524, 525, 526, 527, 528, 529, 530, 531, 532, 533, 534, 534, 535, 536, 537, 538, 538, 539, 540, 541, 542, 543, 544, 545, 546, 547, 548, 549, 550, 551, 552, 553, 554, 555, 556, 557, 558, 559, 560, 561, 562, 563, 564, 565, 566, 567, 568, 569, 570, 571, 572, 573, 574, 575, 576, 577, 578, 579, 580, 581, 582, 583, 584, 585, 586, 587, 588, 589, 590, 591, 592, 593, 594, 595, 596, 597, 598, 599, 600, 601, 602, 603, 604, 605, 606, 607, 608, 609, 610, 611, 612, 613, 614, 615, 616, 617, 618, 619, 620, 621, 622, 623, 624, 625, 626, 627, 628, 629, 630, 631, 632, 633, 634, 635, 636, 637, 638, 639, 640, 641, 642, 643, 644, 645, 646, 647, 648, 649, 650, 651, 652, 653, 654, 655, 656, 657, 658, 659, 660, 661, 662, 663, 664, 665, 666, 667, 668, 669, 670, 671, 672, 673, 674, 675, 676, 677, 678, 679, 680, 681, 682, 683, 684, 685, 686, 687, 688, 689, 690, 691, 692, 693, 694, 695, 696, 697, 698, 699, 700, 701, 702, 703, 704, 705, 706, 707, 708, 709, 710, 711, 712, 713, 714, 715, 716, 717, 718, 719, 720, 721, 722, 723, 724, 725, 726, 727, 728, 729, 730, 731, 732, 733, 734, 735, 736, 737, 738, 739, 740, 741, 742, 743, 744, 745, 746, 747, 748, 749, 750, 751, 752, 753, 754, 755, 756, 757, 758, 759, 760, 761, 762, 763, 764, 765, 766, 767, 768, 769, 770, 771, 772, 773, 774, 775, 776, 777, 778, 779, 780, 781, 782, 783, 784, 785, 786, 787, 788, 789, 790, 791, 792, 793, 794, 795, 796, 797, 798, 799, 800, 801, 802, 803, 804, 805, 806, 807, 808, 809, 810, 811, 812, 813, 814, 815, 816, 817, 818, 819, 820, 821, 822, 823, 824, 825, 826, 827, 828, 829, 830, 831, 832, 833, 834, 835, 836, 837, 838, 839, 840, 841, 842, 843, 844, 845, 846, 847, 848, 849, 850, 851, 852, 853, 854, 855, 856, 857, 858, 859, 860, 861, 862, 863, 864, 865, 866, 867, 868, 869, 870, 871, 872, 873, 874, 875, 876, 877, 878, 879, 880, 881, 882, 883, 884, 885, 886, 887, 888, 889, 890, 891, 892, 893, 894, 895, 896, 897, 898, 899, 900, 901, 902, 903, 904, 905, 906, 907, 908, 909, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 930, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 975, 976, 977, 978, 979, 980, 981, 982, 983, 984, 985, 986, 987, 988, 989, 990, 991, 992, 993, 994, 995, 996, 997, 998, 999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1071, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1376, 1377, 1378, 1379, 1380, 1381, 1381, 1382, 1383, 1383, 1384, 1384, 1385, 1386, 1386, 1387, 1388, 1388, 1389, 1389, 1390, 1390, 1390, 1391, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1398, 1399, 1399, 1399, 1400, 1400, 1400, 1400, 1400, 1401, 1401, 1401, 1401, 1402, 1402, 1402, 1402, 1402, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1404, 1404, 1404, 1404, 1404, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1402, 1402, 1402, 1401, 1401, 1400, 1400, 1399, 1399, 1398, 1397, 1397, 1396, 1395, 1394, 1393, 1392, 1391, 1390, 1389, 1388, 1387, 1386, 1385, 1384, 1384, 1383, 1382, 1381, 1381, 1380, 1379, 1379, 1378, 1377, 1377, 1376, 1375, 1375, 1374, 1374, 1373, 1373, 1372, 1371, 1371, 1370, 1370, 1369, 1369, 1369, 1368, 1368, 1367, 1367, 1366, 1365, 1364, 1363, 1362, 1361, 1360, 1359, 1358, 1357, 1357, 1356, 1356, 1355, 1354, 1353, 1352, 1351, 1350, 1349, 1348, 1347, 1346, 1345, 1344, 1344, 1343, 1342, 1341, 1340, 1339, 1338, 1337, 1336, 1335, 1334, 1333, 1332, 1331, 1330, 1329, 1328, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557, 1558, 1559, 1560, 1561, 1561, 1562, 1563, 1564, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1570, 1571, 1571, 1572, 1573, 1573, 1574, 1575, 1576, 1576, 1577, 1577, 1578, 1579, 1579, 1580, 1581, 1582, 1582, 1583, 1584, 1584, 1585, 1585, 1586, 1587, 1588, 1589, 1589, 1590, 1590, 1591, 1591, 1592, 1593, 1593, 1594, 1594, 1595, 1596, 1596, 1596, 1597, 1597, 1597, 1598, 1599, 1599, 1600, 1600, 1601, 1601, 1601, 1601, 1602, 1602, 1602, 1603, 1603, 1603, 1604, 1604, 1605, 1605, 1606, 1606, 1606, 1607, 1607, 1607, 1607, 1608, 1608, 1609, 1609, 1609, 1610, 1610, 1610, 1611, 1611, 1611, 1612, 1612, 1613, 1613, 1614, 1615, 1616, 1616, 1617, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1619, 1619, 1620, 1620, 1621, 1621, 1621, 1622, 1622, 1622, 1623, 1623, 1624, 1624, 1624, 1625, 1625, 1626, 1626, 1626, 1627, 1627, 1627, 1628, 1628, 1628, 1629, 1629, 1629, 1630, 1630, 1630, 1630, 1630, 1631, 1631, 1631, 1631, 1632, 1632, 1632, 1632, 1632, 1633, 1633, 1633, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1634, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1635, 1634, 1634, 1634, 1634, 1634, 1634, 1633, 1632, 1631, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1630, 1629, 1629, 1629, 1629, 1629, 1628, 1628, 1628, 1628, 1628, 1627, 1627, 1627, 1627, 1626, 1626, 1626, 1625, 1625, 1625, 1624, 1624, 1623, 1623, 1623, 1623, 1622, 1621, 1621, 1621, 1620, 1619, 1619, 1618, 1618, 1618, 1617, 1617, 1616, 1616, 1615, 1615, 1615, 1614, 1614, 1613, 1612, 1612, 1611, 1611, 1611, 1610, 1610, 1609, 1608, 1608, 1607, 1606, 1606, 1606, 1605, 1605, 1604, 1603, 1603, 1603, 1602, 1601, 1601, 1600, 1599, 1599, 1598, 1597, 1596, 1596, 1595, 1594, 1593, 1593, 1593, 1592, 1591, 1591, 1590, 1589, 1589, 1588, 1587, 1587, 1586, 1586, 1585, 1585, 1585, 1584, 1583, 1583, 1582, 1581, 1581, 1580, 1579, 1578, 1578, 1577, 1576, 1575, 1574, 1573, 1573, 1573, 1572, 1571, 1570, 1569, 1568, 1567, 1566, 1565, 1564, 1564, 1563, 1562, 1561, 1560, 1559, 1558, 1557, 1556, 1555, 1554, 1553, 1552, 1551, 1550, 1549, 1548, 1547, 1546, 1545, 1544, 1543, 1542, 1541, 1540, 1539, 1538, 1537, 1536, 1535, 1534, 1533, 1532, 1531, 1530, 1529, 1528, 1527, 1526, 1525, 1524, 1523, 1522, 1521, 1520, 1519, 1518, 1517, 1516, 1515, 1514, 1513, 1512, 1511, 1510, 1509, 1508, 1507, 1506, 1505, 1504, 1503, 1502, 1501, 1500, 1499, 1498, 1497, 1496, 1495, 1494, 1493, 1492, 1491, 1490, 1489, 1488, 1487, 1486, 1485, 1484, 1483, 1482, 1481, 1480, 1479, 1478, 1477, 1476, 1475, 1474, 1473, 1472, 1471, 1470, 1469, 1468, 1467, 1466, 1465, 1464, 1463, 1462, 1461, 1460, 1459, 1458, 1457, 1456, 1455, 1454, 1453, 1452, 1451, 1450, 1449, 1448, 1447, 1446, 1445, 1444, 1443, 1442, 1441, 1440, 1439, 1438, 1437, 1436, 1435, 1434, 1433, 1432, 1431, 1430, 1429, 1428, 1427, 1426, 1425, 1424, 1423, 1422, 1421, 1420, 1419, 1418, 1417, 1416, 1415, 1414, 1413, 1412, 1411, 1410, 1409, 1408, 1407, 1406, 1405, 1404, 1403, 1402, 1401, 1400, 1399, 1398, 1397, 1396, 1395, 1394, 1393, 1392, 1391, 1390, 1389, 1388, 1387, 1386, 1385, 1384, 1383, 1382, 1381, 1380, 1379, 1378, 1377, 1376, 1375, 1374, 1373, 1372, 1371, 1370, 1369, 1368, 1367, 1366, 1365, 1364, 1363, 1362, 1361, 1360, 1359, 1358, 1357, 1356, 1355, 1354, 1353, 1352, 1351, 1350, 1349, 1348, 1347, 1346, 1345, 1344, 1343, 1342, 1341, 1340, 1339, 1338, 1337, 1336, 1335, 1334, 1333, 1332, 1331, 1330, 1329, 1328, 1327, 1326, 1325, 1324, 1325, 1326, 1327, 1327, 1328, 1329, 1330, 1330, 1331, 1332, 1333, 1333, 1333, 1334, 1335, 1335, 1335, 1336, 1336, 1336, 1337, 1337, 1337, 1337, 1338, 1338, 1339, 1339, 1340, 1340, 1340, 1341, 1341, 1341, 1341, 1342, 1342, 1342, 1343, 1343, 1343, 1344, 1344, 1344, 1344, 1344, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1344, 1343, 1342, 1341, 1340, 1339, 1338, 1338, 1338, 1337, 1337, 1337, 1337, 1337, 1337, 1337, 1336, 1336, 1335, 1335, 1335, 1334, 1334, 1334, 1333, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1332, 1331, 1331, 1331, 1331, 1331, 1331, 1331, 1331, 1331, 1330, 1330, 1330, 1330, 1330, 1329, 1329, 1329, 1328, 1328, 1327, 1327, 1327, 1326, 1326, 1326, 1325, 1325, 1325, 1324, 1323, 1322, 1321, 1321, 1320, 1319, 1318, 1318, 1318, 1317, 1317, 1316, 1315, 1314, 1313, 1313, 1313, 1312, 1311, 1311, 1310, 1309, 1308, 1307, 1307, 1306, 1305, 1304, 1304, 1303, 1302, 1301, 1300, 1299, 1298, 1297, 1296, 1295, 1294, 1293, 1292, 1291, 1290, 1289, 1288, 1287, 1286, 1285, 1284, 1283, 1282, 1281, 1280, 1279, 1278, 1277, 1276, 1275, 1274, 1273, 1272, 1271, 1270, 1269, 1268, 1267, 1266, 1265, 1264, 1263, 1262, 1261, 1260, 1259, 1258, 1257, 1256, 1255, 1254, 1253, 1252, 1251, 1250, 1249, 1248, 1247, 1246, 1245, 1244, 1243, 1242, 1241, 1240, 1239, 1238, 1237, 1236, 1235, 1234, 1233, 1232, 1231, 1230, 1229, 1228, 1227, 1226, 1225, 1224, 1223, 1222, 1221, 1220, 1219, 1218, 1217, 1216, 1215, 1214, 1213, 1212, 1211, 1210, 1209, 1208, 1207, 1206, 1205, 1204, 1203, 1202, 1201, 1200, 1199, 1198, 1197, 1196, 1195, 1194, 1193, 1192, 1191, 1190, 1189, 1188, 1187, 1186, 1185, 1184, 1183, 1182, 1181, 1180, 1179, 1178, 1177, 1176, 1175, 1174, 1173, 1172, 1171, 1170, 1169, 1168, 1167, 1166, 1165, 1164, 1163, 1162, 1161, 1160, 1159, 1158, 1157, 1156, 1155, 1154, 1153, 1152, 1151, 1150, 1149, 1148, 1147, 1146, 1145, 1144, 1143, 1142, 1141, 1140, 1139, 1138, 1137, 1136, 1135, 1134, 1133, 1132, 1131, 1130, 1129, 1128, 1127, 1126, 1125, 1124, 1123, 1122, 1121, 1120, 1119, 1118, 1117, 1116, 1115, 1114, 1113, 1112, 1111, 1110, 1109, 1108, 1107, 1106, 1105, 1104, 1103, 1102, 1101, 1100, 1099, 1098, 1097, 1096, 1095, 1094, 1093, 1092, 1091, 1090, 1089, 1088, 1087, 1086, 1085, 1084, 1083, 1082, 1081, 1080, 1079, 1078, 1077, 1076, 1075, 1074, 1073, 1072, 1071, 1070, 1069, 1068, 1067, 1066, 1065, 1064, 1063, 1062, 1061, 1060, 1059, 1058, 1057, 1056, 1055, 1054, 1053, 1052, 1051, 1050, 1049, 1048, 1047, 1046, 1045, 1044, 1043, 1042, 1041, 1040, 1039, 1038, 1037, 1036, 1035, 1034, 1033, 1032, 1031, 1030, 1029, 1028, 1027, 1026, 1025, 1024, 1023, 1022, 1021, 1020, 1019, 1018, 1017, 1016, 1015, 1014, 1013, 1012, 1011, 1010, 1009, 1008, 1007, 1006, 1005, 1004, 1003, 1002, 1001, 1000, 999, 998, 997, 996, 995, 994, 993, 992, 991, 990, 989, 988, 987, 986, 985, 984, 983, 982, 981, 980, 979, 978, 977, 976, 975, 974, 973, 972, 971, 970, 969, 968, 967, 966, 965, 964, 963, 962, 961, 960, 959, 958, 957, 956, 955, 954, 953, 952, 951, 950, 949, 948, 947, 946, 945, 944, 943, 942, 941, 940, 939, 938, 937, 936, 935, 934, 933, 932, 931, 930, 929, 928, 927, 926, 925, 924, 923, 922, 921, 920, 919, 918, 917, 916, 915, 914, 913, 912, 911, 910, 909, 908, 907, 906, 905, 904, 903, 902, 901, 900, 899, 898, 897, 896, 896, 895, 894, 893, 892, 891, 890, 889, 888, 887, 886, 885, 884, 883, 882, 881, 880, 879, 878, 878, 878, 877, 876, 875, 874, 873, 872, 871, 870, 869, 868, 867, 866, 865, 864, 863, 862, 861, 860, 859, 858, 857, 856, 856, 855, 854, 853, 852, 851, 850, 849, 848, 847, 846, 845, 844, 843, 842, 841, 840, 839, 838, 837, 836, 835, 834, 833, 833, 832, 832, 831, 831, 830, 829, 828, 827, 826, 825, 824, 823, 822, 821, 820, 819, 818, 818, 817, 816, 815, 814, 814, 813, 812, 811, 810, 809, 808, 807, 806, 805, 804, 803, 802, 801, 800, 799, 798, 797, 796, 795, 794, 793, 792, 791, 790, 789, 788, 787, 786, 785, 784, 783, 782, 781, 780, 779, 778, 777, 776, 775, 774, 773, 772, 771, 770, 769, 768, 767, 766, 765, 764, 764, 763, 762, 761, 760, 759, 758, 757, 756, 755, 754, 753, 752, 751, 750, 749, 748, 747, 747, 746, 745, 744, 743, 742, 741, 740, 739, 738, 737, 736, 735, 734, 733, 733, 732, 731, 730, 729, 728, 727, 726, 726, 725, 724, 723, 722, 721, 720, 719, 718, 717, 716, 715, 714, 713, 712, 711, 710, 709, 708, 707, 706, 705, 704, 703, 702, 701, 700, 699, 698, 697, 696, 695, 694, 693, 692, 691, 690, 689, 688, 687, 686, 685, 684, 683, 682, 681, 680, 679, 678, 677, 676, 675, 674, 673, 672, 671, 670, 669, 668, 667, 666, 665, 664, 663, 662, 661, 660, 659, 658, 657, 656, 655, 654, 653, 652, 651, 650, 649, 648, 647, 646, 645, 644, 643, 642, 641, 640, 639, 638, 637, 636, 635, 634, 633, 632, 631, 630, 629, 628, 627, 626, 625, 624, 623, 622, 621, 620, 619, 618, 617, 616, 615, 614, 613, 612, 611, 610, 609, 608, 607, 606, 605, 604, 603, 602, 601, 600, 599, 598, 597, 596, 595, 594, 593, 592, 591, 590, 589, 588, 587, 586, 585, 584, 583, 582, 581, 580, 579, 578, 577, 576, 575, 574, 573, 572, 571, 570, 569, 568, 567, 566, 565, 564, 563, 562, 561, 560, 559, 558, 557, 556, 555, 554, 553, 552, 551, 550, 549, 548, 547, 546, 545, 544, 543, 542, 541, 540, 539, 538, 537, 536, 535, 534, 533, 532, 531, 530, 529, 528, 527, 526, 525, 524, 523, 522, 521, 520, 519, 518, 517, 516, 515, 514, 513, 512, 511, 510, 509, 508, 507, 506, 505, 504, 503, 502, 501, 500, 499, 498, 497, 496, 495, 494, 493, 492, 491, 490, 489, 488, 487, 486, 485, 484, 483, 482, 481, 480, 479, 478, 477, 476, 475, 474, 473, 472, 471, 470, 469, 468, 467, 466, 465, 464, 463, 462, 461, 460, 459, 458, 457, 456, 455, 454, 453, 452, 451, 450, 449, 448, 447, 446, 445, 444, 443, 442, 441, 440, 439, 438, 437, 436, 435, 434, 433, 432, 431, 430, 429, 428, 427, 426, 425, 424, 423, 422, 422, 421, 420, 419, 419, 418, 417, 416, 415, 414, 414, 413, 412, 411, 410, 409, 408, 407, 406, 405, 404, 403, 402, 401, 400, 400, 399, 398, 398, 397, 397, 396, 395, 394, 393, 393, 392, 391, 391, 390, 390, 389, 388, 388, 387, 387, 386, 385, 385, 384, 384, 383, 382, 382, 381, 381, 380, 380, 379, 379, 378, 378, 377, 377, 376, 376, 376, 375, 375, 374, 374, 373, 373, 372, 372, 372, 371, 370, 370, 369, 369, 368, 368, 368, 367, 367, 367, 366, 366, 366, 366, 366, 365, 365, 364, 364, 364, 363, 363, 363, 362, 362, 362, 362, 361, 361, 361, 360, 360, 360, 360, 360, 360, 360, 360, 359, 359, 359, 359, 359, 359, 358, 358, 358, 358, 357, 357, 357, 357, 357, 357, 357, 356, 356, 356, 356, 356, 356, 356, 356, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354 };
    private string xxx;
    private string yyy;
    private string[] subsx;
    private string[] subsy;
    //public static int[] xx;
    //public static int[] yy;


    private Vector3[] vertices;
    private int[] triangles;
    public MeshFilter meshFilter;

    void Start()
    {
        string param = (PlayerPrefs.GetString("_id")); //returns ".Net Framework"
        string id1 = param.Replace("\"", "");

        StartCoroutine(GetWebData("http://192.168.80.1:3000/patch/", id1));

        cubeObject = new GameObject("Default Cube", typeof(MeshFilter), typeof(MeshRenderer));
        mesh = new Mesh();
        CreateMesh();
        mesh.name = "Default Cubesss";

        mesh.vertices = vertices;
        mesh.triangles = triangles;
        cubeObject.GetComponent<MeshFilter>().mesh = mesh;
        mesh.RecalculateNormals();
        GameObject Image = GameObject.Find("ImageTarget");
        cubeObject.transform.SetParent(Image.transform);
        cubeObject.transform.position = Vector3.zero;
        cubeObject.transform.localScale = new Vector3(0.00005f, 0.00005f, 0.00005f);

        //cubeObject.AddComponent<MeshCollider>();
        //cubeObject.GetComponent<MeshCollider>().sharedMesh = meshFilter.mesh;

        //meshcol = cubeObject.GetComponent<MeshCollider>();
        //meshcol.bounds;

        Object AllObjects = cubeObject  as Object;
        

        exportMesh(AllObjects);


    }

    private void CreateMesh()
    {
        string xxxx = (PlayerPrefs.GetString("_xx")); //returns ".Net Framework"
        string yyyy = (PlayerPrefs.GetString("_yy")); //returns ".Net Framework"

        subsx = xxxx.Split(',');
        subsy = yyyy.Split(',');

        int p = subsx.Length - 2;
        int o = subsy.Length - 2;



        int[] xx = new int[p];
        int[] yy = new int[o];
        //Debug.Log(subsx[1]);
        //Debug.Log(Type.GetType(subsx[1]));
        //Debug.Log(subsy);


        for (int i = 0; i < p; i++)
        {
            //int x = int.Parse($"{subsx[i]}");

            xx[i] = int.Parse(subsx[i]);
        }
        for (int j = 0; j < o; j++)
        {
            int t = int.Parse(subsy[j]);

            yy[j] = t;
        }

        vertices = new Vector3[xx.Length*2];
        for (int i = 0; i < xx.Length; i++)
        {
            vertices.SetValue(new Vector3(xx[i], 0, yy[i]), i);

        }
        
        for (int i = 0; i < xx.Length; i++)
        {
            vertices.SetValue(new Vector3(xx[i], 20, yy[i]), i+ xx.Length);

        }
        

        int n = xx.Length * 2;
        int m = xx.Length;
        triangles = new int[(m * 6)];


        int k = 0;
        int x = 0;
        int y = n / 2;
        int z = y + 1;
        int s = x + 1;

        while (k < ((m*6)-6))
        {
            triangles[k] = x;
            triangles[k + 1] = y;
            triangles[k + 2] = z;
            triangles[k + 3] = x;
            triangles[k + 4] = z;
            triangles[k + 5] = s;
            




            k = k + 6;
            if (s == (n / 2))
            {
                x = s;
                y = z;
                z = (n / 2) + 1;
                s = 0;
            }
            else
            {
                x = s;
                y = z;
                z = y + 1;
                s = x + 1;
            }
        }


    }
    void exportMesh(UnityEngine.Object objects)
    {
        /*
        string path = Path.Combine(Application.persistentDataPath, "data");
        //string path = Path.Combine("C:/Users/yassine derbel/Desktop");
        path = Path.Combine(path, "carmodel" + ".fbx");

        //Create Directory if it does not exist
        if (!Directory.Exists(Path.GetDirectoryName(path)))
        {
            Directory.CreateDirectory(Path.GetDirectoryName(path));
        }

        FBXExporter.ExportGameObjToFBX(objMeshToExport, path, true, true);
        */
        string filePath = Path.Combine(Application.dataPath, "MyGame.fbx");
        ModelExporter.ExportObject(filePath, objects);

    }
    IEnumerator GetWebData(string address, string myID)
    {
        UnityWebRequest www = UnityWebRequest.Get(address + myID);
        yield return www.SendWebRequest();

        if (www.result != UnityWebRequest.Result.Success)
        {
            Debug.LogError("Something went wrong: " + www.error);
        }
        else
        {
            Debug.Log(www.downloadHandler.text);
            Patch patch = new Patch();

            //var response = JObject.Parse(www.downloadHandler.text);
            //patch = JsonConvert.DeserializeObject<Patch>(response.SelectToken("imageCreated"));


            string json = www.downloadHandler.text;


            patch = JsonUtility.FromJson<Patch>(json);
            xxx = patch.corX;
            yyy = patch.corY;

            PlayerPrefs.SetString("_xx", xxx);
            PlayerPrefs.SetString("_yy", yyy);
            /*
            subsx = xxx.Split(',');
            subsy = yyy.Split(',');
            int p = subsx.Length - 2;
            int o = subsy.Length - 2;



            int[] xx = new int[p];
            int[] yy = new int[o];
            //Debug.Log(subsx[1]);
            //Debug.Log(Type.GetType(subsx[1]));
            //Debug.Log(subsy);


            for (int i = 0; i <p ; i++)
            {
                //int x = int.Parse($"{subsx[i]}");

                xx[i] = int.Parse(subsx[i]);
            }
            for (int j = 0; j < o; j++)
            {
                int t = int.Parse(subsy[j]);

                yy[j] = t;
            }
            */
        }
    }
    /*
    void ProcessServerResponse(string rawResponse)
    {
        // That text, is actually JSON info, so we need to 
        // parse that into something we can navigate.

        JSONNode node = JSON.Parse(rawResponse);

        // Output some stuff to the console so that we know
        // that it worked.

        Debug.Log("Username: " + node["username"]);
        Debug.Log("Misc Data: " + node["someArray"][1]["name"] + " = " + node["someArray"][1]["value"]);
    }
    */
    /*
    IEnumerator GetRequest(string uri)
    {
        using (UnityWebRequest webRequest = UnityWebRequest.Get(uri))
        {
            // Request and wait for the desired page.
            yield return webRequest.SendWebRequest();

            string[] pages = uri.Split('/');
            int page = pages.Length - 1;

            switch (webRequest.result)
            {
                case UnityWebRequest.Result.ConnectionError:
                case UnityWebRequest.Result.DataProcessingError:
                    Debug.LogError(pages[page] + ": Error: " + webRequest.error);
                    break;
                case UnityWebRequest.Result.ProtocolError:
                    Debug.LogError(pages[page] + ": HTTP Error: " + webRequest.error);
                    break;
                case UnityWebRequest.Result.Success:
                    Debug.Log(pages[page] + ":\nReceived: " + webRequest.downloadHandler.text);
                    break;
            }
        }
    }
    */
    // Update is called once per frame
    void Update()
    {
        
    }
}
